﻿
<%@ Page Inherits="Microsoft.Crm.Web.Activities.AppointmentDetailPage" CodeBehind="Microsoft.Crm.Application.Pages.Activities.dll"%>
<%@ Register TagPrefix="frm" Namespace="Microsoft.Crm.Application.Forms.Activities" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="mnu" Namespace="Microsoft.Crm.Application.Menus" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="cnt" Namespace="Microsoft.Crm.Application.Controls" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Import Namespace="Microsoft.Crm.Application.Types"%>
<html>
<head><META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=UTF-8"/>
<link rel="stylesheet" type="text/css" href="/_controls/datetime/timeedit.css">
<script language="JavaScript" src="/_controls/datetime/time.js"></script>
<cnt:AppHeader id="crmHeader" runat="server" />
<script language="JavaScript" src="/Activities/appointment/appointment.js"></script>
<script language="JavaScript">

	function window.onload( )
	{
        <% RenderFocusControl( ); %>
        <% RenderInitCalendar( ); %>
	}
	
	///
	/// Sets the current users workday
	//
	function setWorkday( )
	{
		<% RenderSetWorkday(); %>
		
		_workdayStartPlusHalfHour = new Date( _workdayStart );
		_workdayStartPlusHalfHour.setMinutes( _workdayStartPlusHalfHour.getMinutes( ) + 30 );
	}

</script>
</head>
<body scroll="no">
<frm:ActivityForm id="crmForm" runat="server">	

<table cellspacing="0" cellpadding="0" width="100%" height="100%">
	<tr height="48">
		<td>
			<mnu:AppFormMenuBar id="crmMenuBar" runat="server" /> 
		</td>
	</tr>
	<% RenderConflictingAppointments( ); %>
	<tr>
		<td style="padding:5">
			<table width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="25">
					<td>
						<cnt:AppTabBar id="crmTabBar" runat="server" />
					</td>
				</tr>
				<tr>
					<td>
						<div class="tab" id="tab0" style="display:inline;">
							<table cellpadding="3" cellspacing="0" width="100%" height="100%" style="table-layout:fixed;">
								<col width="90"><col><col width="10"><col width="90"><col width="10"><col>
								<tr style="padding-top:10px;">
									<td>Organizer</td>
									<td colspan="5">

										<% crmActivityForm.RenderOrganizerLookup( 1 ); %>
									</td>
								</tr>
								<tr>
									<td>Attendees</td>
									<td colspan="5">
										<% crmActivityForm.RenderPartyLookup( ActivityParticipantCode.RequiredAttendee, 2 ); %>
									</td>
								</tr>
								<tr>
									<td class="req">Subject</td>
									<td colspan="5"><cnt:AppTextInputControl id="subject" TabIndex="3" required maxlength="200" runat="server"/></td>
								</tr>
								<tr>
									<td>Location</td>
									<td colspan="5">
										<cnt:AppTextInputControl id="location" TabIndex="4" maxlength="200" runat="server"/>
									</td>
								</tr>
								<tr>
									<td class="req">Start Time</td>
									<td colspan="3"><cnt:AppDateTimeControl id="scheduledstart" TabIndex="5" runat="server" AllowBlankDate="False" oninitcomplete="initDates();" /></td>
									<td></td>
									<td>
										<input type="checkbox" tabindex="7" <%= crmActivityForm.ReadOnly || crmActivityForm.Disabled ? "disabled" : "" %> onclick="setAllDay()" id="chkAllDay" name="crmFormChkAllDay" style="border:0px; width:20px" <%=( _allDayEvent ? "checked" : "") %>>
										<label for="chkAllDay" style="cursor:<%= crmActivityForm.ReadOnly || crmActivityForm.Disabled ? "default;" : "hand;" %>">All day event</label>
										<input type="hidden" name="alldayevent" value="<%=( _allDayEvent ? "1" : "0") %>">
									</td>
								</tr>
								<tr>
									<td class="req">End Time</td>
									<td colspan="3"><cnt:AppDateTimeControl id="scheduledend" TabIndex="6" runat="server" AllowBlankDate="False" oninitcomplete="initDates();" /></td>
									<td colspan="2"></td>
								</tr>
								<tr>
									<td colspan="6" height="100%"><cnt:AppMemoControl id="description" TabIndex="8" runat="server" maxlength="2000"/></td>
								</tr>
									<tr>
										<td>Regarding</td>
										<td colspan="4">
<%
											crmActivityForm.RenderRegardingLookup( 9 );
%>
										</td>
										<td>
											<table cellpadding="0" cellspacing="0" width="100%" height="19px">
												<tr>
													<td onClick="javascript:
	  												try 
												  	{
														var SpellChecker = new ActiveXObject('ieSpell.ieSpellExtension');
													    	SpellChecker.CheckAllLinkedDocuments(window);
													    	delete spellchecker;
													} catch (e) {
													    	alert('Spell-check failed to load.  Error: '+e.message);
													}" 
													style="filter:	progid:DXImageTransform.Microsoft.Gradient(GradientType=0, StartColorStr=#ffffff, EndColorStr=#cecfde);
													cursor:	hand;font-size: 11px;text-aligh: center;padding-left: 5px;padding-right: 5px;border: 1px solid #7b9ebd">
														<center>Spell Check</center>
													</td>
												</tr>
											</table>
										</td>
									</tr>
								<tr>
									<td>Owner</td>
									<td colspan="5"><% crmActivityForm.RenderOwnerLookup( 10 ); %></td>

								</tr>
								<tr>
									<td>Duration</td>
									<td><cnt:AppDurationControl runat="server" TabIndex="11" OnInitComplete="initDates();" id="scheduleddurationminutes"/></td>
									<td></td>
									<td>Priority</td>
									<td></td>
									<td><cnt:AppPicklistControl id="prioritycode" TabIndex="12" runat="server" type="priority"/></td>
								</tr>	
								<tr>
									<td>Category</td>
									<td><cnt:AppTextInputControl runat="server" TabIndex="13" maxlength="250" id="category"/></td>
									<td></td>
									<td>Sub-Category</td>
									<td></td>
									<td><cnt:AppTextInputControl runat="server" TabIndex="14" maxlength="250" id="subcategory"/></td>
								</tr>							
							</table>
						</div>
						<% if( crmForm.State == Microsoft.Crm.Application.Forms.FormState.Existing ) {%>
						<div id="tab1" class="tab" style="display:none;padding:10px;">	
							<table width="100%" height="100%" cellspacing="0" cellpadding="0">
								<tr height="23">
									<td><mnu:AppGridMenuBar id="crmGridMenuBar" runat="server"/></td>
								</tr>
								<tr>
									<td><cnt:AppGrid id="crmGrid" runat="server"/></td>
								</tr>
							</table>
						</div>
						<% } %>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<% crmActivityForm.RenderFooter( ); %>
</table>

</frm:ActivityForm>
</body>
</html>