﻿
<%@ Page Inherits="Microsoft.Crm.Web.Activities.EmailDetailPage" CodeBehind="Microsoft.Crm.Application.Pages.Activities.dll"%>
<%@ Register TagPrefix="frm" Namespace="Microsoft.Crm.Application.Forms.Activities" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="mnu" Namespace="Microsoft.Crm.Application.Menus" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="cnt" Namespace="Microsoft.Crm.Application.Controls" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="cal" Namespace="Microsoft.Crm" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="crm" Namespace="Microsoft.Crm.Controls" Assembly="Microsoft.Crm.Application.Components.UI" %>
<%@ Import Namespace="Microsoft.Crm.Application.Types"%>
<html>
<head><META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=UTF-8"/>
<cnt:AppHeader id="crmHeader" runat="server" />
<link rel="stylesheet" type="text/css" href="/_controls/htmlbar/htmlbar.css">

<script language="JavaScript">

	function window.onload()
	{
		// override the crmForm.Save method
		//
		crmForm._bUseCustomSaveEvent = true;
		crmForm.attachEvent("onsave", Save);
<%
		if (crmActivityForm._emailType == EmailActivityForm.EmailType.Draft && 
			crmActivityForm.PrivilegeCheck.CanWrite )
		{
			Response.Write(@"MessageBody.document.designMode = ""on"";");
		}

		if (!_email.Disabled)
		{
			Response.Write("crmForm.messagesubject.focus();");
		}

		RenderOnloadScript();
		RenderInitCalendar();
%>
	}
	
	// Do not cancel event bubbling from the onbeforeunload event (which calls this function) because
	// that event is also handled in the form.htc code
	function UpdateMessageBody(bSetDefault)
	{	
		if (MessageBody.document.readyState == "complete")
		{
			crmForm.messagebody.value = MessageBody.document.body.innerHTML;
			
			if (bSetDefault)
			{
				crmForm.messagebody.defaultValue = crmForm.messagebody.value;
			}
		}
	}

	function Save(event)
	{
<%
		if (crmActivityForm._emailType == EmailActivityForm.EmailType.Draft &&
			crmActivityForm.PrivilegeCheck.CanWrite)
		{
			Response.Write("UpdateMessageBody();");
		}
%>
		crmForm.SubmitCrmForm(event.Mode, true, false, (event.Mode == 2));
	}


	function send()
	{
		var oNodes = crmFormSubmit.childNodes;
		var hasRecip = false;
		var hasSender = false;
		
		// check to see if there have been any recipients added
		for ( i = 0; i < oNodes.length; i++ )
		{
			var oCurrent = oNodes.item( i );
			if ( oCurrent.name == "partycode" )
			{
				if ( oCurrent.value == <%= (int)ActivityParticipantCode.ToRecipient %> || 
						oCurrent.value == <%= (int)ActivityParticipantCode.CcRecipient %> || 
						oCurrent.value == <%= (int)ActivityParticipantCode.BccRecipient %>
					)
				{
					hasRecip = true;
				}
				if ( oCurrent.value == <%= (int)ActivityParticipantCode.Sender %> )
				{
					hasSender = true;
				}

			}				
			if (hasRecip && hasSender)
				break;
		}
			
		if ( !hasRecip )
		{
			alert("The e-mail must have at least one recipient before it can be sent.");
			return;
		}

		if ( !hasSender )
		{
			alert("The e-mail must have a sender. Select a sender in the From box.");
			return;
		}

		UpdateMessageBody();
		// Force a submit, in case an addressee's email address has been filled in
		crmForm.prioritycode.defaultValue = "";
		crmForm.SubmitCrmForm(<%=(int)FormEventId.EmailSend%>, true, true, false);
	}

	function reply()
	{
		openFrmObj( "<% RenderReplyParams(); %>", buildWinName(), EmailActivity );
	}

	function replyall()
	{
		openFrmObj( "<% RenderReplyAllParams(); %>", buildWinName(), EmailActivity );
	}

	function forward()
	{
		openFrmObj( "<% RenderForwardParams(); %>", buildWinName(), EmailActivity );
	}
	
	//	remove a party with a specific address from the form
	// returns true if the party was found and deleted, false otherwise
	function DeleteParty( iPartyCode, sPartyName ) 
	{
		var partyIdElems = document.getElementsByName("partyid");
		var partyTypeElems = document.getElementsByName("partytype");
		var partyCodeElems = document.getElementsByName("partycode");
		var partyNameElems = document.getElementsByName("partyname");
		var partyAddressElems = document.getElementsByName("partyaddressused");
		var partyContactInfoElems = document.getElementsByName("contactInfo");
		

		for( var i = 0; i < partyCodeElems.length; i++ ) 
		{
			if( partyCodeElems[i].value == iPartyCode && 
				partyTypeElems[i].value == 0 &&
				partyNameElems[i].value == sPartyName )
			{
				partyIdElems[i].removeNode();
				partyTypeElems[i].removeNode();
				partyNameElems[i].removeNode();
				partyCodeElems[i].removeNode();
				partyAddressElems[i].removeNode();
				partyContactInfoElems[i].removeNode();

				return true;
			}
		}

		return false; 
	}

	function resolveAddress( sAddress, iPartyCode )
	{
		var lookupItem = event.srcElement;
		
		var url = "resolve.aspx?address=" + sAddress;
		var returnObject = openStdDlg( url, null, 450, 450 );
		if ( returnObject )
		{
			var bResult = DeleteParty(iPartyCode, sAddress);
			if (!bResult)
			{
				alert("Error - the recipient could not be placed properly");
				return;
			}

			// swap out the lui with the new values
			lookupItem.oid = returnObject.id;
			lookupItem.otype = returnObject.type;
			lookupItem.onclick = function f() { openObj(this.otype, this.oid); };
			lookupItem.className = "lui";	
			lookupItem.innerHTML = "<img class='lui' src='/_imgs/ico_16_" + returnObject.type + ".gif'>" + returnObject.name;

			SetParty(returnObject.id, iPartyCode, returnObject.name, returnObject.type);
			
			//	hack to force a submit
			//			
			crmForm.actualstart.defaultValue = "";				
		}
	}

	function TemplateTarget( oid, otype)
	{
		this.oid = oid;
		this.otype = otype;
	}

	function ChooseTemplateTarget()
	{	
		var oNodes = crmFormSubmit.childNodes;

		// Walk the nodes and build the query string for the resolution dialog
		var sUrl = "/activities/email/dlg_template_target.aspx?";

		// Also, save the last selectedid and type in case we only find one element
		var oSelectedId, oSelectedType;

		// Keep track of whether we've found more elements than we can display in the lookup
		var bAlert = false;

		// Keep track of whether we've found more than one element
		var nObjects = 0;

		// Now check the regarding object
		if (crmForm.objectid.value != null && crmForm.objectid.value != "" && 
			crmForm.objecttypecode.value != null && crmForm.objecttypecode.value != "")
		{
			nObjects++;
			var sUrlElement = "oid=" + encodeURIComponent(crmForm.objectid.value) + 
				"&otype=" + encodeURIComponent(crmForm.objecttypecode.value) + 
				"&oname=" + encodeURIComponent(crmForm.objectid.parentNode.parentNode.innerText) + "&opart=re&";
			if (sUrl.length + sUrlElement.length < 2000)
				sUrl += sUrlElement;
			else
				bAlert = true;

			oSelectedId = crmForm.objectid.value;
			oSelectedType = crmForm.objecttypecode.value;
		}

		for (var iCount = 0; iCount < oNodes.length; iCount++)
		{
			var oTempId, oTempType, oTempPartyName;

			var oCurrent = oNodes.item(iCount);
			if (oCurrent.name == "partyid")
			{
				oTempId = encodeURIComponent(oCurrent.value);
			}
			else if (oCurrent.name == "partytype")
			{
				oTempType = encodeURIComponent(oCurrent.value);
			}
			else if (oCurrent.name == "partyname")
			{
				oTempPartyName = encodeURIComponent(oCurrent.value);
			}
			else if (oCurrent.name == "partycode" && oCurrent.value == <%= (int)ActivityParticipantCode.ToRecipient %>)
			{
				// Check the object type, and only proceed if it is not a queue (see bug 23300)
				if ( oTempType != Queue )
				{
					nObjects++;
					var sUrlElement = "oid=" + oTempId + "&otype=" + oTempType + "&oname=" + oTempPartyName + "&opart=to&";
					if (sUrl.length + sUrlElement.length < 2000)
						sUrl += sUrlElement;
					else
						bAlert = true;
					oSelectedId = oTempId;
					oSelectedType = oTempType;
				}
			}
			else if (oCurrent.name == "partycode" && oCurrent.value == <%= (int)ActivityParticipantCode.CcRecipient %>)
			{
				// Check the object type, and only proceed if it is not a queue (see bug 23300)
				if ( oTempType != Queue )
				{				
					nObjects++;
					var sUrlElement = "oid=" + oTempId + "&otype=" + oTempType + "&oname=" + oTempPartyName + "&opart=cc&";
					if (sUrl.length + sUrlElement.length < 2000)
						sUrl += sUrlElement;
					else
						bAlert = true;
					oSelectedId = oTempId;
					oSelectedType = oTempType;
				}
			}
		}


		if (nObjects == 0)
		{
			alert("You must add at least one recipient to the To, Cc, or Regarding box before you can insert a template.");
			return null;
		}

		if (nObjects > 1)
		{
			if (bAlert)
				alert("You have selected too many targets for the template. The list will be truncated.");

			var sResponse = openStdDlg(sUrl, null, 600, 350);
			if (sResponse == null)
				return;

			oSelectedId = sResponse.oid;
			oSelectedType = sResponse.otype;
		}

		return new TemplateTarget(oSelectedId, oSelectedType);
	}

	function ApplyTemplate()
	{
		var oTarget = ChooseTemplateTarget();

		if (oTarget == null)
			return;

		var sUrl = "/_grid/cmds/dlg_bulkemail.aspx?bulkemail=false" + "&objectTypeCode=" + oTarget.otype + "&objectid=" + oTarget.oid;
		var sResponse = openStdDlg(sUrl, null, 600, 350);

		if (sResponse != null)
		{
			MessageBody.focus();
			var sId = "df" + new Date().getTime();
			MessageBody.document.execCommand("InsertButton", null, sId);

			var oButton = MessageBody.document.all(sId);

			var oTemplate = MessageBody.document.createElement("SPAN");

			oTemplate.innerHTML = sResponse;

			oButton.replaceNode(oTemplate);
		}
	}


	function EmailSenderLookup( oDiv, lookupStyle, sLookupTypes )
	{
		var lookupField = oDiv;
		// User = 8
		// Queue = 2020
		var lookupItems = LookupObjects( lookupField, lookupStyle, "ActivitySender", sLookupTypes, 0 );

		// Sender = 1
		partyCode = 1;
		if (lookupItems)
		{
			//	strip all parties of this type
			DeleteParties( partyCode );

			if ( lookupItems.items.length > 0 ) 
			{
				var item		= lookupItems.items[0];
				var partyId		= item.id;
				var partyType	= item.type;
				var partyName	= item.name;

				SetParty( partyId, partyCode, partyName, partyType );
			}
		}		

		//	hack to force a submit
		//			
		crmForm.prioritycode.defaultValue = "FORCESUBMIT";
	}
	
	function assignEmail( )
	{
		crmForm.SubmitCrmForm(<%=(int)FormEventId.EmailAssign%>, true, true, false);	
	}

	function unblock()
	{
		if (window.confirm("You are about to view a message body that might contain harmful content.  Click OK to proceed or Cancel to stop."))
		{
			var o = window.open("msgBody.aspx?unblockContent=1&id=<%=_email.Id%>", null, "width=700,height=500,menubar=1,status=1,resizable=1,scrollbars=1");
			// To prevent malicious email code from accessing this form (the opener window)
			o.opener = null;
			o.focus();
		}
	}

</script>

<style>

	SPAN.lun
	{
		color:				#ff0000;
		text-decoration:	underline;
		cursor:				hand;
	}
	
	SPAN.luu
	{
		color:				#ff0000;
		text-decoration:	underline;
		cursor:				hand;
	}
	
	IMG.luu
	{
		height:				16px;
		width:				16px;
		vertical-align:		middle; 
		margin-left:		2px;
		margin-right:		5px;
	}
	
	td.info
	{
		background-Color:#ffffcc;
		border: 1px solid #919276;
	}
	
	span.button
	{
		background-Color:#ffffff;
		border: 1px solid #919191;
		cursor: hand;
	}
	
	iframe.editPage
	{
		background-color: #ffffff; 
		height: 100%; 
		width: 100%; 
		overflow: auto;
		border: 1px solid #7b9ebd;
	}

</style>
</head>

<body scroll="no" onbeforeunload="UpdateMessageBody();">

<frm:EmailActivityForm id="crmForm" runat="server">
<input type="hidden" name="messagebody">
	
	<table cellspacing="0" cellpadding="0" width="100%" height="100%">
		<tr height="48">
			<td>
				<mnu:AppFormMenuBar id="crmMenuBar" runat="server" /> 
			</td>
		</tr>
		<% RenderInfoMessage(); %>
		<tr>
			<td style="padding:5px">
				<table width="100%" height="100%" cellspacing="0" cellpadding="0">
					<tr height="25">
						<td>
							<cnt:AppTabBar id="crmTabBar" runat="server" />
						</td>
					</tr>
					<tr>
						<td>
							<div class="tab" id="tab0" style="display:inline;">
								<table cellpadding="3" cellspacing="0" width="100%" height="100%" style="table-layout:fixed;">
									<col width="90"><col><col width="10"><col width="90"><col>
									<tr>
										<td>From</td>
										<td><% crmActivityForm.RenderEmailSenderLookup( 1 ); %></td>
										<td></td>
										<td>Cc</td>
										<td><% crmActivityForm.RenderPartyLookup( ActivityParticipantCode.CcRecipient, 3 ); %></td>
									</tr>

									<tr>
										<td>To</td>
										<td><% crmActivityForm.RenderPartyLookup( ActivityParticipantCode.ToRecipient, 2 ); %></td>
										<td></td>
										<td>Bcc</td>
										<td><% crmActivityForm.RenderPartyLookup( ActivityParticipantCode.BccRecipient, 4 ); %></td>
									</tr>
									
									<tr>
										<td>Subject</td>
										<td colspan="4"><cnt:AppTextInputControl id="messagesubject" TabIndex="5" required="false" maxlength="200" runat="server" /></td>
									</tr>
									<tr>
										<td colspan="5" height="100%">
											<table width="100%" height="100%" cellpadding="0" cellspacing="0">
<%
												if (crmActivityForm._emailType == EmailActivityForm.EmailType.Draft &&
													crmActivityForm.PrivilegeCheck.CanWrite )
												{	
%>
												<tr height="26">
													<td>
														<crm:HtmlBar type="EmailActivity" runat="server"/>
													</td>
												</tr>
<%
												}

												RenderMessageBody();
%>
											</table>
											

										</td>
									</tr>
									
									<tr>
										<td>Regarding</td>
										<td colspan="3">
<%
											crmActivityForm.RenderRegardingLookup( 7 );
%>
										</td>
										<td>
											<table cellpadding="0" cellspacing="0" width="100%" height="19px">
												<tr>
													<td onClick="javascript:
	  												try 
												  	{
														var SpellChecker = new ActiveXObject('ieSpell.ieSpellExtension');
													    	SpellChecker.CheckAllLinkedDocuments(window);
													    	delete spellchecker;
													} catch (e) {
													    	alert('Spell-check failed to load.  Error: '+e.message);
													}" 
													style="filter:	progid:DXImageTransform.Microsoft.Gradient(GradientType=0, StartColorStr=#ffffff, EndColorStr=#cecfde);
													cursor:	hand;font-size: 11px;text-aligh: center;padding-left: 5px;padding-right: 5px;border: 1px solid #7b9ebd">
														<center>Spell Check</center>
													</td>
												</tr>
											</table>
										</td>
									</tr>

									<tr>
										<td>Owner</td>
										<td colspan="4"><%crmActivityForm.RenderOwnerLookup( 8 );%></td>
									</tr>

									<tr>
										<td>Duration</td>
										<td>
<% 
											string strActualStart = CurrentUser.LocalDateTimeAsString;
											
											Response.Write(@"<input name=""actualstart"" type=""hidden"" value=""");
											Response.Write(strActualStart);
											Response.Write(@""" returnValue=""");
											Response.Write(strActualStart);
											Response.Write(@""">");
											
											if (crmActivityForm._emailType == EmailActivityForm.EmailType.Draft)
											{
												Response.Write(@"<input name=""directioncode"" type=""hidden"" value=""");
												Response.Write(Microsoft.Crm.Platform.Types.EVENT_DIRECTION.ED_OUTGOING);
												Response.Write(@""" returnValue=""");
												Response.Write(Microsoft.Crm.Platform.Types.EVENT_DIRECTION.ED_OUTGOING);
												Response.Write(@""">");
											}
											
%>											<cnt:AppDurationControl runat="server" TabIndex="9" id="actualdurationminutes"/>
										</td>
										<td></td>
										<td>Priority</td>
										<td>
											<cnt:AppPicklistControl id="prioritycode" TabIndex="11" runat="server" type="priority"/>
										</td>
									</tr>
									<tr>
										<td>Due</td>
										<td colspan="1">
											<cnt:AppDateTimeControl id="scheduledstart" TabIndex="10" runat="server"/>
										</td>
										<td colspan="2">
										</td>
									</tr>
									<tr>
										<td>Category</td>
										<td><cnt:AppTextInputControl runat="server" TabIndex="12" maxlength="250" id="category"/></td>
										<td></td>
										<td>Sub-Category</td>
										<td><cnt:AppTextInputControl runat="server" TabIndex="13" maxlength="250" id="subcategory"/></td>
									</tr>
								</table>
							</div>
<%
					if (crmForm.State == Microsoft.Crm.Application.Forms.FormState.Existing)
					{
%>
							<div id="tab1" class="tab" style="display:none;padding:10px;">
								<table width="100%" height="100%" cellspacing="0" cellpadding="0">
									<tr height="23">
										<td><mnu:AppGridMenuBar id="crmAttachmentGridMenuBar" runat="server"/></td>
									</tr>
									<tr>
										<td><cnt:AppGrid id="crmAttachmentGrid" runat="server"/></td>
									</tr>
								</table>
							</div>
<%
					}
					else
					{
%>
							<div id="tab1" class="tab" style="display:none;padding:10px;">
								<table width="100%" height="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td align="center" style="color:#999999;font-size:12px;">You must save this e-mail prior to adding attachments to it.</td>
									</tr>
								</table>
							</div>
<%
					}
%>
						</td>
					</tr>
				</table>
				<% crmActivityForm.RenderFooter(); %>
			</td>
		</tr>
	</table>
</frm:EmailActivityForm>
</body>
</html>