﻿
<%@ Page Inherits="Microsoft.Crm.Web.Activities.FaxDetailPage" CodeBehind="Microsoft.Crm.Application.Pages.Activities.dll"%>
<%@ Register TagPrefix="frm" Namespace="Microsoft.Crm.Application.Forms.Activities" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="mnu" Namespace="Microsoft.Crm.Application.Menus" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Register TagPrefix="cnt" Namespace="Microsoft.Crm.Application.Controls" Assembly="Microsoft.Crm.Application.Components.Application" %>
<%@ Import Namespace="Microsoft.Crm.Application.Types"%>
<html>
<head><META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=UTF-8"/>
<cnt:AppHeader id="crmHeader" runat="server" />

<script language="javascript">

	var sPrevDirectionCode = "";
	
	function window.onload( )
	{
		sPrevDirectionCode = crmForm.directioncode.returnValue;
		<% RenderFocusControl( ); %>
		<% RenderInitCalendar( ); %>
	}		
	
	function onDirectionChange()
	{
		// Swap the two.
		if( swapLookups(  crmForm.senderLookup
			        , <%=(int) ActivityParticipantCode.Sender%>
			        , crmForm.recipientLookup
			        , <%=(int) ActivityParticipantCode.ToRecipient%> ) )
		{
			// A successful swap
			sPrevDirectionCode = crmForm.directioncode.returnValue;
		}
		else
		{
			// Unsuccessful swap-- restore the original incoming/outgoing direction.
			directioncodeControl.setValue( sPrevDirectionCode );
		}
	}

</script>
</head>
<body>
<frm:ActivityForm id="crmForm" runat="server">
	<table cellspacing="0" cellpadding="0" width="100%" height="100%">
		<tr height="48">
			<td>
				<mnu:AppFormMenuBar id="crmMenuBar" runat="server" /> 
			</td>
		</tr>
		<tr>
			<td style="padding:5">
				<table width="100%" height="100%" cellspacing="0" cellpadding="0">
					<tr height="25">
						<td>
							<cnt:AppTabBar id="crmTabBar" runat="server" />
						</td>
					</tr>
					<tr>
						<td>
							<div class="tab" id="tab0" style="display:inline;">
								<table cellpadding="3" cellspacing="0" width="100%" height="100%" style="table-layout:fixed;">
									<col width="90"><col><col width="10"><col width="90"><col>
									<tr>
										<td>Sender</td>
										<td><% crmActivityForm.RenderSenderLookup( 1 ); %></td>
										<td></td>
										<td>Fax Number</td>
										<td>
											<cnt:AppTextInputControl TabIndex="3" id="location" maxlength="200" runat="server"/>
										</td>
									</tr>
									<tr>
										<td>Recipient</td>
										<td><% crmActivityForm.RenderPartyLookup(ActivityParticipantCode.ToRecipient, "recipientLookup", 2 ); %>
										</td>
										<td></td>
										<td>Direction</td>
										<td>
											<cnt:AppPicklistControl id="directioncode" TabIndex="4" runat="server" type="direction" onchange="onDirectionChange();"/>
										</td>
									</tr>
									<tr>
										<td class="req">Subject</td>
										<td colspan="4">
											<cnt:AppTextInputControl id="subject" TabIndex="5" required maxlength="200" runat="server"/>
										</td>
									</tr>
									<tr>
										<td colspan="5" height="100%">
											<cnt:AppMemoControl id="description" TabIndex="6" runat="server" maxlength="2000"/>
										</td>
									</tr>
									<tr>
										<td>Regarding</td>
										<td colspan="3">
<%
											crmActivityForm.RenderRegardingLookup( 7 );
%>
										</td>
										<td>
											<table cellpadding="0" cellspacing="0" width="100%" height="19px">
												<tr>
													<td onClick="javascript:
	  												try 
												  	{
														var SpellChecker = new ActiveXObject('ieSpell.ieSpellExtension');
													    	SpellChecker.CheckAllLinkedDocuments(window);
													    	delete spellchecker;
													} catch (e) {
													    	alert('Spell-check failed to load.  Error: '+e.message);
													}" 
													style="filter:	progid:DXImageTransform.Microsoft.Gradient(GradientType=0, StartColorStr=#ffffff, EndColorStr=#cecfde);
													cursor:	hand;font-size: 11px;text-aligh: center;padding-left: 5px;padding-right: 5px;border: 1px solid #7b9ebd">
														<center>Spell Check</center>
													</td>
												</tr>
											</table>
										</td>
									</tr>

									<tr>
										<td class="req">Owner</td>
										<td colspan="4">
<%
											crmActivityForm.RenderOwnerLookup( 8 );
%>
										</td>
									</tr>
									<tr>
										<td>Duration</td>
										<td>
											<cnt:AppDurationControl runat="server" TabIndex="9" id="actualdurationminutes"/>
										</td>
										<td></td>
										<td>Priority</td>
										<td>
											<cnt:AppPicklistControl id="prioritycode" TabIndex="11" runat="server" type="priority"/>
										</td>
									</tr>
									<tr>
										<td>Due</td>
										<td colspan="1">
											<cnt:AppDateTimeControl id="scheduledstart" TabIndex="10" runat="server"/>
										</td>
										<td colspan="2">
										</td>
									</tr>
									<tr>
										<td>Category</td>
										<td><cnt:AppTextInputControl runat="server" TabIndex="12" maxlength="250" id="category"/></td>
										<td></td>
										<td>Sub-Category</td>
										<td><cnt:AppTextInputControl runat="server" TabIndex="13" maxlength="250" id="subcategory"/></td>
									</tr>	
									</table>
							</div>
							<% if( crmForm.State == Microsoft.Crm.Application.Forms.FormState.Existing ) {%>
							<div id="tab1" class="tab" style="display:none;padding:10px;">	
								<table width="100%" height="100%" cellspacing="0" cellpadding="0">
									<tr height="23">
										<td><mnu:AppGridMenuBar id="crmGridMenuBar" runat="server"/></td>
									</tr>
									<tr>
										<td><cnt:AppGrid id="crmGrid" runat="server"/></td>
									</tr>
								</table>
							</div>
							<% } %>
						</td>
					</tr>
				</table>
			</td>
		</tr>
<%
		crmActivityForm.RenderFooter();
%>
	</table>
</frm:ActivityForm>
</body>
</html>